<template>
    <div :class="{'white-block':block}">
        <div class="padding" v-if="block">
            <h3>Контрольный вопрос</h3>
        </div>
        <hr v-if="block"/>
        <div class="row padding">
            <div class="columns four">
                <label for="controlQuestionType">Контрольный вопрос</label>
                <multiselect v-model="fieldControlQuestionType"
                             :options="controlQuestionTypeStatus"
                             :searchable="false"
                             :close-on-select="true"
                             :show-labels="false"
                             placeholder=""
                             id="controlQuestionType"
                             :preserve-search="true"
                             label="title"
                             track-by="id"
                             @input="getControlQuestionType"
                             :vValidateRules="'required'"
                             name="fieldControlQuestionType"
                             data-code="controlQuestionTypeInvalidFormat, controlQuestionTypeNotInAvailableRange"
                >
                </multiselect>
                <validate-message v-show="vErrors.has('fieldControlQuestionType')">
                    {{ vErrors.first('fieldControlQuestionType') }}
                </validate-message>
            </div>

            <div class="columns four hidden"> <!-- Этот блок выводим, если он выбрал вариант "Свой вопрос"-->
                <label for="security-question-own">Введите свой вопрос</label>
                <input type="text" name="security-question-own" id="security-question-own" placeholder="" value=""/>
            </div>
            <transition name="slide-fade">
                <div class="columns four" v-if="fieldControlQuestionType.id == 3">
                    <!-- Это поле выводим после того, как юзер что-то выбрал в селекторе "Свой вопрос"-->
                    <label for="controlQuestion">Ваша подсказка</label>
                    <input type="text"
                           name="controlQuestion"
                           id="controlQuestion"
                           v-model="$user.controlQuestion"
                           v-validate="'required|cyrillic|min:2|max:50'"
                           :class="getValidateClass('controlQuestion')"
                           @input.prevent="rusLangAndSetValue"
                           autocomplete="off"
                           data-code="controlQuestionTooShort, controlQuestionTooLong"
                    />
                    <validate-message v-show="vErrors.has('controlQuestion')">
                        {{ vErrors.first('controlQuestion') }}
                    </validate-message>
                </div>
            </transition>
            <div class="columns four"> <!-- Это поле выводим после того, как юзер что-то выбрал в селекторе-->
                <label for="controlAnswer">Ответ</label>
                <input type="text"
                       name="controlAnswer"
                       id="controlAnswer"
                       :value="$user.controlAnswer"
                       :class="getValidateClass('controlAnswer')"
                       v-validate="'required|cyrillic|min:2|max:50'"
                       @input.prevent="rusLangAndSetValue"
                       autocomplete="off"
                       data-code="controlAnswerTooShort, controlAnswerTooLong, controlAnswerInvalidFormat"
                />
                <validate-message v-show="vErrors.has('controlAnswer')">
                    {{ vErrors.first('controlAnswer')}}
                </validate-message>
            </div>
        </div>
    </div>
</template>

<script>
    // test
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  export default {
    mixins: [
      UserGetter,
      UserSetter,
      GetValidateClass
    ],
    data () {
      return {
        fieldControlQuestionType: [{id: 1, title: 'Девичья фамилия матери'}],
        controlQuestionTypeStatus: [
          {id: 1, title: 'Девичья фамилия матери'},
          {id: 2, title: 'Кличка домашнего животного'},
          {id: 3, title: 'Свой вопрос'}
        ]
      }
    },
    props: {
      profile: {
        type: Boolean,
        default: false
      },
      block: {
        type: Boolean,
        default: false
      }
    },
    created () {
      this.$user.controlQuestionType = 1;
    },

    computed: {
      controlQuestionType () {
        this.fieldControlQuestionType = this.controlQuestionTypeStatus[this.$user.controlQuestionType - 1]
        return this.fieldControlQuestionType
      }
    },
    methods: {
      rusLangAndSetValue (e) {
        this.$validator.errors.clear()
        e.preventDefault()
        if (/^[а-яА-Я]*$/.test(e.target.value)) {
            this.$user[e.target.id] = e.target.value
        }
        if (e.target.value === '') {
          this.$user[e.target.id] = e.target.value
        }
      },
      getControlQuestionType (arg) {
        if (arg.title !== 'Свой вопрос') {
          this.$user.controlQuestion =  null;
          this.$user.controlQuestionType = arg.id;
        } else {
            this.$user.controlQuestionType = 3;
        }
      }
    }
  }
</script>

<style scoped>

</style>
